#!/bin/ksh

#Obtener la hora y dia actuales
strhora=`date +20%y%m%d%H%M%S`
#Obtener la fecha actual
strfecha=`date +20%y%m%d`

basecomienzo=$HOME/scripts

#Indicar la ruta donde se van a crear los directorios
basedir=$basecomienzo/Reenvio_GIS
strpathenvios=$basedir/Envio_$strhora

#Crear los directorios si no existen. Si existen se deshecha el error y se continua
salidas=$strpathenvios/altasbajasmod_$strhora
#log=$strpathenvios/log_$strhora.log
#logerror=$strpathenvios/logerror_$strhora.log
logerror=/tmp/logerror

#Colocarse en el directorio de comienzo
if test -d $basecomienzo
then
	cd $basecomienzo
else
	echo "ERROR. No se encuentra el Path de comienzo. El proceso finalizara ($strhora)." >> $logerror
	exit 0
fi

#mkdir $basedir 2>/dev/null
#mkdir $strpathenvios 2>/dev/null

#touch $log
touch $logerror

#SQLPLUS


#Comprimir y borrar ficheros
strdia=`date +%d`
strmes=`date +%m`
stranio=`date +20%y`

stranio=$1
strmes=$2
strdia=$3

#echo "$stranio$strmes$strdia" >> $logerror

#Escribir en el log:
#echo " Control de Errores de Reenvio_GIS.ksh " >> $log
#echo " ----------------------------------------------" >> $log
#echo " " >> $log
#echo " Listado de Flujo y errores producidos: " >> $log
#echo " ----------------------------------------------" >> $log
#echo " " >> $log

#Contar el numero de directorios que se van a comprimir
strbuscar=`ls -l $basedir | grep ^d.* | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$strfecha.* | wc -l`
#
# if [ $strbuscar -eq 0 ]
# then
# 	echo "Error, no existen directorios a comprimir." >> $logerror
# 	break
# else
# 	#Devuelve los nombres de los directorios que hay que comprimir
# 	for i in `ls -l $basedir | grep ^d.* | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$strfecha.*`
# 	do
# 		strdirec=$basedir/$i
#
# echo "Comprobando $i, strfecha=$strfecha"
#
# 		#Si el directorio tiene un tar se borra y posterirmente se volvera a crear
# 		if [ -f "$basedir/$i.tar" ]
# 		then
# 			#Si existe un archivo con el mismo nombre que se va a utilizar, se elimina
# 			`rm "$basedir/$i.tar" 2>$logerror`
# 		fi
#
# 		if [ ! -f "$basedir/$i.tar.bz2" ]
# 		then
# 			echo "Comprimiendo $i"
#
# 			#Empaquetar y comprimir el directorio
# 			`tar -cvf "$basedir/$i.tar" "$strdirec/" > $logerror 2>&1`
# 			`bzip2 -z "$basedir/$i.tar" > $logerror 2>&1`
#
# 			if [ $? -eq 0 ]
# 			then
# 				echo "Se ha creado el archivo $i.tar.bz2" >> $log
				#Borrar el directorio correspondiente
#				`rm -r "$basedir/$i">/dev/null`
# 			else
# 				echo "Error, no se pudo comprimir el directorio $i" >> $logerror
# 			fi
# 		fi
# 	done
# fi

#******************************************************************************
#Borra los archivos y directorios (un mes antes)
#******************************************************************************
#Dias de cada mes
#E=31, F=28,29, M=31, A=30, M=31, J=30, J=31, A=31, S=30, O=31, N=30, D=31

#Borrar un directorio
#Recibe como parametros: nombre del directorio
borrar_directorio(){
echo "Borrando directorio: $basedir/$1" >> $logerror
	ruta="$basedir/$1"
	if test -d $ruta
	then
		`rm -r $ruta`
		if [ $? -eq 0 ] #Si se ha borrado correctamente
		then
			echo "Se ha borrado el directorio $ruta" >> $logerror
		fi
	fi
}
#Borrar un archivo
#Recibe como parametros: nombre del archivo
borrar_archivo(){
	echo "Borrando fichero: $basedir/$1" >> $logerror

	ruta=$basedir/$1
	`rm $ruta`
	if [ $? -eq 0 ] #Si se ha borrado correctamente
	then
		echo "Se ha borrado el archivo $ruta" >> $logerror
	fi
}

if [ $strdia -eq 01 -a $strmes -eq 03 ]
then
	#Si es dia 1 y el mes 3 (Marzo), borrar los dias 29, 30 y 31 de enero que no se borran en febrero
	#En el caso de que febrero sea bisiesto, borrar solo el 30 y 31
	if [ $stranio%4 -eq -0 ] && [ $stranio%100 -ne 0 -o $stranio%400 -eq 0 ]
	then
		#Borrar: 30 y 31 de enero y el 1 de febrero
		strmes="01"
		strdia="30"
		for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio$strmes$strdia.*\.tar\.bz2`
		do
			`rm "$basedir/$j">/dev/null`
		done

		strmes="01"
		strdia="31"
		for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio$strmes$strdia.*\.tar\.bz2`
		do
			`rm "$basedir/$j">/dev/null`
		done

		strmes=02
		strdia=01
		for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio$strmes$strdia.*\.tar\.bz2`
		do
			`rm "$basedir/$j">/dev/null`
		done
	else
		#Borrar: 29, 30 y 31 de enero y el 1 de febrero
		strmes=01
		strdia=29
		for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio$strmes$strdia.*\.tar\.bz2`
		do
			`rm "$basedir/$j">/dev/null`
		done

		strmes=01
		strdia=30
		for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio$strmes$strdia.*\.tar\.bz2`
		do
			`rm "$basedir/$j">/dev/null`
		done

		strmes=01
		strdia=31
		for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio$strmes$strdia.*\.tar\.bz2`
		do
			`rm "$basedir/$j">/dev/null`
		done

		strmes=02
		strdia=01
		for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio$strmes$strdia.*\.tar\.bz2`
		do
			`rm "$basedir/$j">/dev/null`
		done
	fi
elif [ $strdia -eq 01 ] && [ $strmes -eq 5 -o $strmes -eq 7 -o $strmes -eq 10 -o $strmes -eq 12 ]
then
	#Si es dia 1 y es el mes siguiente a alguno de los que tienen 30 dias
	#(abril, junio, septiembre y noviembre), borrar el dia 31 de hace dos meses

	#Borrar el archivo del dia del mes anterior
	strmes_anterior=`expr $strmes - 1`
	if [ $strmes_anterior -lt 10 ]
	then
		strmes_anterior=0$strmes_anterior
	fi

	for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio$strmes_anterior$strdia.*\.tar\.bz2`
	do
		`rm "$basedir/$j">/dev/null`
	done

	#Borrar el dia 31 que no se borro porque el mes que ha terminado tenia 30 dias
	strmes_anterior=`expr $strmes - 2`
	if [ $strmes_anterior -lt 10 ]
	then
		strmes_anterior=0$strmes_anterior
	fi

	strdia="31"
	for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio$strmes_anterior$strdia.*\.tar\.bz2`
	do
		`rm "$basedir/$j">/dev/null`
	done
else
	stranio_buscar=$stranio
	if [ $strmes -eq 01 ]
	then
		stranio_buscar=`expr $stranio - 1`
		strmes_anterior=12
	else
		strmes_anterior=`expr $strmes - 1`
		if [ $strmes_anterior -lt 10 ]
		then
			strmes_anterior=0$strmes_anterior
		fi
	fi

	#Borrar todos los .tar.bz2 de hace un mes
	for j in `ls -l $basedir | tr -s ' ' | cut -d' ' -f9 | grep ^Envio_$stranio_buscar$strmes_anterior$strdia.*\.tar\.bz2`
	do
		`rm "$basedir/$j">/dev/null`
	done
fi

