#!/bin/bash

if [ $# -eq 0 ]
then
	echo "Error. Modo de uso: $0 <patron>"
	echo ""
	echo "Ejemplos:"
	echo "         $0 jpg"
	echo "         $0 JPG"
	echo ""
	exit 1
fi

x=0
y=0
TAMANO=800
TAMANO_PEQ=165
JORNADA='9jornadase'

echo "-------------------------------------------------------------------------"
echo "¿Dispone de una copia de las fotos?"
echo "Se eliminaran las fotos originales y se dejaran unicamente las de $TAMANO px de ancho o alto."
echo "¿Desea continuar con el escalado y perder las fotos originales? [s/n]"
read respuesta
if [ ! -z $respuesta ]
then
	if [ $respuesta = "s" -o $respuesta = "S" ]
	then
		echo "Se sobreescribiran las fotos, comenzando..."
	else
		echo "Saliendo..."
		exit 2
	fi
else
		echo "No ha introducido una respuesta. Saliendo..."
		exit 3
fi

echo ""
echo "-------------Fase 1: Escalado--------------"
for i in `ls *.$1`
do
	#x=`exif $i | grep PixelXDimension | cut -d'|' -f2`
	#y=`exif $i | grep PixelYDimension | cut -d'|' -f2`
	x=`identify -format "%w" $i`
	y=`identify -format "%h" $i`

	if [ -z "$x" ]
	then
		echo "Error, imposible obtener el ancho de $i"
	fi
	if [ -z "$y" ]
	then
		echo "Error, imposible obtener el alto de $i"
	fi

	if [ $x -ge $y -a $x -le $TAMANO ]
	then
		echo "$i ($x x $y) no supera el minimo, debe tener mas de $TAMANO px de ancho, omitiendo..."
	elif [ $y -ge $x -a $y -le $TAMANO ]
	then 
		echo "$i ($x x $y) no supera el minimo, debe tener mas de $TAMANO px de alto, omitiendo..."
	else		
		if [ $x -ge $y ]
		then
			echo "Imagen $i ($x x $y)"
			convert -geometry $TAMANO $i $i
		else
			echo "Imagen $i ($x x $y)"
			convert -geometry x$TAMANO $i $i
		fi
		x=`identify -format "%w" $i`
		y=`identify -format "%h" $i`
		echo "                => ($x x $y)"
	fi
done

echo ""
echo "-------------Fase 2: Renombrado--------------"
echo "Modificando nombres..."
for i in `ls *.$1`
do
    j=$(($j+1))
    if [ $j -lt 10 ]; then
        mv $i $JORNADA"0$j.jpg"
        echo "     $i -->" $JORNADA"0$j.jpg"
    else
        mv $i $JORNADA"$j.jpg"
        echo "     $i --> $JORNADA$j.jpg"
    fi
done

echo ""
echo "-------------Fase 3: Generado de imagen peq.--------------"
echo "Escalando fotos a $TAMANO_PEQ px..."
for i in `ls *.$1`
do
    convert -geometry $TAMANO_PEQ $i ${i/.jpg}_peq.jpg
    echo "     Generado ${i/.jpg}_peq.jpg"
done

echo ""
echo "Finalizado correctamente."
echo ""
