#!/bin/ksh
#-------------------------------------------------------------------------------------------------------------------
# Script que realiza la extraccion de base de datos
#
# Valores de salida:    0 - proceso finalizado OK.
#                       1 - Error: Error en la conexion a la base de datos
#			2 - El proceso no debe ejecutarse (param_table con PS_EJECUCION igual a NO)
#-------------------------------------------------------------------------------------------------------------------

VARENTORNO='.varentorno'
. $VARENTORNO

#Elimina los espacios en blanco sobrantes en el fichero generado de la consulta SQL
function tratar_fichero
{
	fp=$AP_PATH"/"$ffamily_pack
	fp_tmp=$AP_PATH"/"fichero_tmp
        touch $fp_tmp
        
	while read linea
        do
                echo "$linea" | awk -F";" '{print $1";"$2";"$3";"$4";"$5";"$6";"}' >> $fp_tmp
        done < $fp
        mv $fp_tmp $fp
}

vstrconn="connect $AP_DBUSER/$AP_DBPASS@$AP_SERVER" 
DATABASE="$AP_DBUSER/$AP_DBPASS@$AP_SERVER"

sqlplus  -s /nolog |&
print -p -- $vstrconn
print -p -- 'set feed off pause off pages 0 head off veri off line 500'
print -p -- 'set term off time off'
read  -p dummy
print -p -- "select count(*) from param_table where cadena='PS_EJECUCION' and valor='NO';"
read  -p ejecucion

if [ $dummy != "Connected." ]
then
    exit 1
else
    if [ $ejecucion -ne 0 ]
    then
      echo "<`date`> El proceso no debe ejecutarse." > $AP_PATH_LOGS"/"$AP_LOG_FILE
      exit 2
    fi
fi

extension=".txt"

dia=`date +%d`
mes=`date +%m`
anio=`date +20%y`
fecha=$anio"_"$mes"_"$dia

# Genero el fichero de datos
echo "<`date`> Generando fichero" > $AP_PATH_LOGS"/"$AP_LOG_FILE

ffamily_pack=`sqlplus -s $DATABASE @$AP_PATH_SQL/fic_ps_fp.sql $fecha $AP_PATH $extension` 

#Eliminar los espacios sobrantes del fichero generado
tratar_fichero

#Utilizado para pruebas:
#lineas_ffamily_pack=`wc -l $ffamily_pack | awk '{ print $1 }'`
#echo "$lineas_ffamily_pack"
#echo "<`date`> Fichero generado" >> $AP_PATH_LOGS"/"$AP_LOG_FILE
#echo "Lineas $lineas_ffamily_pack"

exit 0
