#!/bin/ksh
#---------------------------------------------------------------------------
# Script principal que realiza las llamadas a los modulos fic_ps_fp y
# ftp_ps_fp para hacer la extraccion de base de datos y un envio FTP
#
# Valores de salida:    0 - Proceso finalizado OK.
#                       1 - Error: Error en la extraccion del fichero.
#                       2 - Error: Error en el envio FTP del fichero. 
#			3 - Error: El fichero .varentorno no existe o esta vacio.
#---------------------------------------------------------------------------

if [ ! -s ".varentorno" ]
then
	echo "Error: El fichero .varentorno no existe o esta vacio." | tee ERROR_VARENTORNO_NO_EXISTE 
	exit 3
fi

VARENTORNO='.varentorno'
. $VARENTORNO


# Llamada a proceso de generacion de fichero
$AP_PATH"/"fic_ps_fp.sh
# Respuesta de generaciOn de fichero
vretorno=$?
if [ $vretorno -eq 0 ]
then
	# Llamada a proceso de FTP
	$AP_PATH"/"ftp_ps_fp.sh
	# Respuesta de FTP
	vretorno=$?

	if [ $vretorno -eq 0 ]
	then
		echo "<`date`> Proceso terminado" > $AP_PATH_LOGS"/"$AP_LOG_PPAL
		exit 0
	else
		echo "<`date`> Error En FTP: Valor de retorno = $vretorno" > $AP_PATH_LOGS"/"$AP_LOG_PPAL
		exit 2
	fi

else 
	echo "<`date`> Error En Generacion De Fichero: Valor de rentorno = $vretorno" >> $AP_PATH_LOGS"/"$AP_LOG_PPAL
	exit 1
fi
	
	
